#include "maze.h"

void CMaze::drawWall(int x, int y, bool isHorizontal, Color c)
{
    int sx = x * TILE_SIZE;
    int sy = y * TILE_SIZE;

    if (isHorizontal == true)
    {
        int ex = sx + TILE_SIZE - 1;
        int ey = sy + WALL_WIDTH - 1;

        for (int yy = sy; yy <= ey; yy++)
            for (int xx = sx; xx <= ex; xx++)
                gfx.setPixel(xx, yy, c);
    }
    else
    {
        int ex = sx + WALL_WIDTH - 1;
        int ey = sy + TILE_SIZE + WALL_WIDTH - 1;

        for (int yy = sy; yy <= ey; yy++)
            for (int xx = sx; xx <= ex; xx++)
                gfx.setPixel(xx, yy, c);
    }
}

CMaze::CMaze()
{
    // init the maze
    for (int y = 0; y <= MAZE_HEIGHT; y++)
        for (int x = 0; x <= MAZE_WIDTH; x++)
        {
            tiles[x][y].topIsActive  = false;
            tiles[x][y].leftIsActive = false;
        }

    // init left and right borders
    for (int y = 0; y < MAZE_HEIGHT; y++)
    {
        tiles[0][y].leftIsActive = true;
        tiles[0][y].leftColor = Color(255, 255, 255);

        tiles[MAZE_WIDTH][y].leftIsActive = true;
        tiles[MAZE_WIDTH][y].leftColor = Color(255, 255, 255);
    }

    // init top and bottom borders
    for (int x = 0; x < MAZE_WIDTH; x++)
    {
        tiles[x][0].topIsActive = true;
        tiles[x][0].topColor = Color(255, 255, 255);

        tiles[x][MAZE_HEIGHT].topColor = Color(255, 255, 255);
        tiles[x][MAZE_HEIGHT].topIsActive = true;
    }
}

void CMaze::draw()
{
    // draw the maze
    for (int y = 0; y <= MAZE_HEIGHT; y++)
        for (int x = 0; x <= MAZE_WIDTH; x++)
        {
            if (tiles[x][y].leftIsActive == true)
                drawWall(x, y, false, tiles[x][y].leftColor);

            if (tiles[x][y].topIsActive == true)
                drawWall(x, y, true, tiles[x][y].topColor);
        }
}
